use core::ffi::c_void;
use flipperzero_sys as sys;

use crate::{popup_one::TARGET_ICON, App, Views};

pub unsafe extern "C" fn scene_on_enter(context: *mut c_void) {
    let app = context as *mut App;
    sys::popup_reset((*app).popup);
    sys::popup_set_context((*app).popup, context);
    sys::popup_set_header((*app).popup, c"Popup Two".as_ptr(), 64, 10, sys::Align_AlignCenter, sys::Align_AlignTop);
    sys::popup_set_icon((*app).popup, 10, 10, &TARGET_ICON);
    sys::popup_set_text((*app).popup, c"Two! Two popups. (press back)".as_ptr(), 64, 20, sys::Align_AlignLeft, sys::Align_AlignTop);
    sys::view_dispatcher_switch_to_view((*app).view_dispatcher, Views::Popup as u32);
}

pub unsafe extern "C" fn scene_on_event(_context: *mut c_void, _event: sys::SceneManagerEvent) -> bool {
    false // don't handle any events
}

pub unsafe extern "C" fn scene_on_exit(context: *mut c_void) {
    let app = context as *mut App;
    sys::popup_reset((*app).popup);
}
